#!/bin/sh
#*=====================================================================*/
#*    serrano/prgm/project/hop/2.3.x/arch/debian/makedeb.sh            */
#*    -------------------------------------------------------------    */
#*    Author      :  Manuel Serrano                                    */
#*    Creation    :  Sat Dec 22 05:37:50 2007                          */
#*    Last change :  Sat May  5 09:08:12 2012 (serrano)                */
#*    Copyright   :  2007-12 Manuel Serrano                            */
#*    -------------------------------------------------------------    */
#*    The Shell script to build the .deb for Hop on Maemo              */
#*    -------------------------------------------------------------    */
#*    Debug with "sh -x makedeb.sh"                                    */
#*=====================================================================*/

#*---------------------------------------------------------------------*/
#*    Global configuration                                             */
#*---------------------------------------------------------------------*/\

# Gentoo-like P/PN/PV
PN=hiphop
PV=1.0.0
P=${PN}-${PV}
P_=${PN}_${PV}

DISTRIB=
BIGLOOVERSION=3.8b

REPOSITORY=/home/hop
AUTHOR=Cyprien.Nicolas@inria.fr
LICENSE=gpl
TMP=`pwd`/build.${PN}
BASEDIR=`dirname $0`
PREFIX=/usr

if [ "$REPODIR " != " " ]; then
  REPOSITORY=$REPODIR;
fi

#*---------------------------------------------------------------------*/
#*    Create the TMP directories                                       */
#*---------------------------------------------------------------------*/
/bin/rm -rf $TMP
mkdir -p $TMP

#*---------------------------------------------------------------------*/
#*    Untar the standard HipHop version                                */
#*---------------------------------------------------------------------*/
# Make an export of the repository
(cd $REPOSITORY/${PN} && make export)

# Move the source tarball to $REPOSITORY, and rename from .tgz to .tar.gz
mv /tmp/${P}.tgz ${REPOSITORY}/${P}.tar.gz
# Unpack the archive
tar xfz ${REPOSITORY}/${P}.tar.gz -C ${TMP}
# Rename the source directory using the version
 mv ${TMP}/${PN} ${TMP}/${P}
# Create the orig source tarball
tar cfz ${TMP}/${P}.tar.gz -C ${TMP} ${P}

#*---------------------------------------------------------------------*/
#*    Start creating the .deb                                          */
#*---------------------------------------------------------------------*/
(cd $TMP/${P} &&
 dh_make -c $LICENSE -s -e $AUTHOR -f ../${P}.tar.gz <<EOF

EOF
)

mkdir -p $TMP/${P}/debian/

# debian specific
for p in control rules changelog; do
  if [ -f $BASEDIR/debian/$p.in ]; then
    cat $BASEDIR/debian/$p.in \
      | sed -e "s/@HIPHOPVERSION@/$PV/g" \
            -e "s|@PREFIX@|$PREFIX|g" \
            -e "s/@BIGLOOVERSION@/$BIGLOOVERSION/g" > \
      $TMP/${P}/debian/$p;
  else
echo "CP $BASEDIR/debian/$p $TMP/${P}/debian;"
echo "PWD=$PWD";
    cp $BASEDIR/debian/$p $TMP/${P}/debian;
  fi
done

(cd $TMP/${P} && dpkg-buildpackage -rfakeroot)

#*---------------------------------------------------------------------*/
#*    Cleanup tmp files                                                */
#*---------------------------------------------------------------------*/
/bin/rm -f $TMP/${P}.tar.gz
/bin/rm -f $TMP/${P_}.tar.gz
/bin/rm -f $TMP/${P_}.orig.tar.gz

#*---------------------------------------------------------------------*/
#*    Copy the deb file                                                */
#*---------------------------------------------------------------------*/
if [ -d $REPOSITORY/$debianversion ]; then
  cp $TMP/${P_}_armel.deb $REPOSITORY/$debianversion
fi
