(module gas_server

   (library hiphop phidget)

   (export (phidget-ifkit& ::bint ::procedure ::bint ::procedure)
      phidget-machine))


(define phidget-machine #f)

(define (phidget-ifkit& slider-id slider-listener touch-id touch-listener)
   (let* ((ifkit::phidget-ifkit (instantiate::phidget-ifkit))
	  (prog (hiphop&
		   :input (event& "sensor" :multi? #f :default (class-nil phidget-sensorchange-event))
		   :output (event& "slider" :multi? #f :default 500)
		   :output (event& "touch" :multi? #f)
		   :initialize (lambda (the-machine resolve-event)
				  (let ((machine (the-machine))
					(sensor-event (resolve-event "sensor")))
				     (phidget-add-event-listener! ifkit "sensorchange"
					(lambda (e)
					   (hiphop-input-and-react! machine sensor-event e)))
				     (phidget-open ifkit)))
		   (every& (now& "sensor")
		      (seq&
			 (par&
			    (if& (=fx slider-id
				    (with-access::phidget-sensorchange-event (val& "sensor") (index) index))
			       (emit& "slider"
				  (with-access::phidget-sensorchange-event (val& "sensor") (state) state)))
			    (if& (with-access::phidget-sensorchange-event (val& "sensor") (index state)
				    (and (=fx touch-id index)
					 (zerofx? state)))
			       (emit& "touch")))
			 (pause&))))))
      (set! phidget-machine (make-hiphop-machine prog))
      (hiphop-add-event-listener! phidget-machine "slider" slider-listener)
      (hiphop-add-event-listener! phidget-machine "touch" touch-listener)))
