(module hiphop_xhr
   (library hiphop)
   (export (xhr& url)
	   (with-url& url)))

(cond-expand
   (scheme2js
(define (connect-event-listener! req ev M #!optional opt)
   (add-event-listener! req ev
      (lambda (e)
	 (tprint "Got " ev)
	 (hiphop-input-and-react! M (or opt ev) e))))
))

(define (with-url& url)
   (hiphop&
      :name "with-url&"
      :input "load" "error"
      :output "complete" "failed"
      initialize:
      (lambda (the-machine get-name)
	 (let ((m (the-machine))
	       (l (get-name "load"))
	       (e (get-name "error")))
	    (cond-expand
	       (scheme2js
		  (let ((req (js-new (@ XMLHttpRequest js))))
		     (connect-event-listener! req "load"  m l)
		     (connect-event-listener! req "error" m e)
		     (req.open "GET" url #t)
		     (req.send)))
	       (hop
		  (with-url url
		     (lambda (res) (hiphop-input-and-react! m l res))
		     :fail (lambda (res) (hiphop-input-and-react! m e res))))
	       (else
		(if (file-exists? url)
		    (hiphop-input-and-react! m l url)
		    (hiphop-input-and-react! m e url))))))
      (trap& exit
	 (par&
	    (seq&
	       (await& (now& "load"))
	       (emit& "complete" (val& "load"))
	       (exit& exit))
	    (seq&
	       (await& (now& "error"))
	       (emit& "failed" (val& "error"))
	       (exit& exit))))))
(cond-expand
   (scheme2js
(define (xhr& url)
   (hiphop&
      input: "load" "error"
      output: "complete" "failed"
      initialize: (lambda (current-machine get-name)
		     (let ((req (js-new (@ XMLHttpRequest js))))
			(connect-event-listener! req "load"  (current-machine) (get-name "load"))
			(connect-event-listener! req "error" (current-machine) (get-name "error"))
			(req.open "GET" url #t)
			(tprint "req: "req)
			(req.send)))
      (until& (now& "error")
	 (seq&
	    (await& (now& "load"))
	    (emit& "complete" (val& "load")))
	 (handler& (emit& "failed" (val& "error"))))))
   )(else
(define (xhr& url)
    (error "xhr&" "Only available in scheme2js" url))
))
