;; This module export an hiphop program representing a Prey & Predator application
;; Predators chases and eats preys, and die if they cannot eat a prey
(module prey_predator_main

   (library hiphop)

   (import prey_predator_datatypes prey_predator_predator prey_predator_prey)

   (export (prey-predator&::hiphop-program))

   (main test))

(define (prey-predator&)
   (hiphop&
      ;; Interface
      output: (event& "entities" :multi? #t)

      ;; Body
      (local& (; Counters
	       (event& "preys-alive" :combine + :default 0)
	       (event& "chased" :multi? #t) ; list of currently chased preys
	       (event& "eaten" :multi? #t)) ; list of currently eaten preys
	 (par&
	    (run& (preys&))
	    (run& (predators&))))))

(define (test args)
   (let ((M (make-hiphop-machine (prey-predator&))))
      (hiphop-add-event-listener! M "entities" (lambda (e) (pp e)))
      (hiphop-react! M))
   (print "OK"))
