(module prims_pool
   (library hiphop)

   (import  prims_fish)
   (export (pool ::int ::int))

   (main main))

(define finished? #f)

(define (get-values arg)
   (cond
      ((pair? arg)
       (if (any? (lambda (f) (isa? f %fish)) arg)
	   (map (lambda (f::%fish) f.value) arg)
	   arg))
      ((isa? arg %fish)
       (list (with-access::%fish arg (value) value)))
      (else (list arg))))

;;; Build the fish pool
;; n: number of fishes
;; p: number of primes (stop condition) p=pi(n)
(define (pool n p)
   (hiphop& :output "here" "Alive"
      (par&
	 (map (lambda (val) (run& (make-fish-program val))) (iota (-fx n 1) 2))
	 (loop&
	    (pause&)
	    (emit& "Alive" (-fx (length (get-values (val& "here"))) p)))
	 (loop&
	    (pause&)
	    (if& (<=fx (length (val& "here")) p)
	       (atom& (set! finished? #t)))))))

(cond-expand
   (scheme2js
      (define (bigloo-debug-set! val)
	 (let ((debug (@ __sc_traceLevel js)))
	    (set! debug val)))))

(define (main args)
   (bigloo-debug-set! 0)
   (seed-random! 1)
   ;;; Typical values for n and p:
   ; http://primes.utm.edu/howmany.shtml
   ; 10 	4
   ; 100 	25
   ; 500	95
   ; 1,000 	168
   ; 10,000 	1,229
   ; 100,000 	9,592
   ; 1,000,000 	78,498
   (let* ((P (hiphop&
		(local& ("here" "Alive")
		   ; (par&
		      (run& (pool 500 95))
		      ; (loop&
		      ; 	 (await& "Alive")
		      ; 	 (atom& (print "Alive: " (val& "Alive"))))
		      ; )
		)))
	  (M (make-hiphop-machine P)))
      (let react ((instant 0))
	 (if (or finished? (>fx instant 10000))
	     (print "Finished at instant " instant)
	     (begin
		;(print "Instant: " instant)
		(hiphop-react! M)
		(react (+fx instant 1)))))))
