(module wristwatch_stopwatch_datatype

   (import
      wristwatch_beep)

   (export
      ;; classes
      (class stopwatch-time
	 hundredths::bint
	 seconds::bint
	 minutes::bint)

      ;; functions
      (stopwatch-beep-value::beep)
      (zero-stopwatch-time::stopwatch-time)
      (increment-stopwatch-time!::stopwatch-time st::stopwatch-time)
      (stopwatch-beep::beep st::stopwatch-time)))

;; Exports
(define (stopwatch-beep-value::beep) one-beep)

;; Internals
(define hundredths-per-increment 25)
(define hundredths-per-second 100)
(define seconds-per-minute 60)
(define minutes-per-hour 60)
(define minutes-to-beep 1) ; should be 10, but set to 1 for demos

;; API
(define (zero-stopwatch-time::stopwatch-time)
   (instantiate::stopwatch-time (hundredths 0) (seconds 0) (minutes 0)))

(define (increment-stopwatch-time!::stopwatch-time st::stopwatch-time)
   (set! st.hundredths (+fx st.hundredths hundredths-per-increment))
   (when (=fx st.hundredths hundredths-per-second)
      (set! st.hundredths 0)
      (set! st.seconds (+fx st.seconds 1))
      (when (=fx st.seconds seconds-per-minute)
	 (set! st.seconds 0)
	 (set! st.minutes (+fx st.minutes 1))
	 (when (=fx st.minutes minutes-per-hour)
	    (set! st.minutes 0))))
   st)

(define (stopwatch-beep::beep st::stopwatch-time)
   (if (and (zerofx? st.hundredths)
	    (zerofx? st.seconds)
	    (zerofx? (remainder st.minutes minutes-to-beep)))
       (stopwatch-beep-value)
       no-beep-value))
